<!-- eslint-disable @angular-eslint/template/mouse-events-have-key-events -->
<p-table
class="drug-table"
[value]="initDrugOrders | filterOrders: drugOrders()"
styleClass="p-datatable-sm p-datatable-gridlines"
[scrollable]="true"
[resizableColumns]="true"
selectionMode="single"
[scrollHeight]="scrollHeight"
>
<ng-template pTemplate="header">
  <tr>
    <th class="text-align-center">
      <p-button icon="pi pi-plus" styleClass="p-button-rounded p-button-success p-button-form" (click)="onClickNew()"></p-button>
    </th>
    <th class="text-align-center">!</th>
    <th style="min-width:200px;" pFrozenColumn class="frozen-col">{{'藥品名稱' | translate}}</th>
    <th>{{'劑量' | translate}}</th>
    <th>{{'單位' | translate}}</th>
    <th>{{'使用劑量' | translate}}</th>
    <th>{{'途徑' | translate}}</th>
    <th>{{'頻率' | translate}}</th>
    <th class="text-align-center">{{'磨粉' | translate}}</th>
    <th>{{'天數' | translate}}</th>
    <th>{{'總量' | translate}}</th>
    <th>{{'單位' | translate}}</th>
    <th>{{'自費' | translate}}</th>
    <th style="width: 100%">{{'囑咐' | translate}}</th>
    <th>{{'健保價' | translate}}</th>
    <th>{{'自費價' | translate}}</th>
    <th>{{'醫囑代碼' | translate}}</th>
  </tr>
</ng-template>
<ng-template pTemplate="body" let-drugOrder let-index="rowIndex">
  <tr [ngClass]="index | getRowCss: initDrugOrders: drugOrders()">
    <td (mouseover)="selectRow(drugOrder._id)" class="menu">
      <p-menubar class="menu-bar" [model]="index | getStateMenu: initDrugOrders: drugOrders()"></p-menubar>
    </td>
    <td >{{ drugOrder.alertType.display }}</td>
    <td pFrozenColumn class="frozen-col">{{ drugOrder.invCode.display }}</td>
    <td class="text-align-right" (mouseover)="selectRow(drugOrder._id)" [ngClass]="{'error': drugOrder | validate: 'dosage'}">
      <p-inputNumber class="tableInput" [min]="1" [(ngModel)]="drugOrder.dosage.value" [ngClass]="{'error': drugOrder | validate: 'dosage'}" (keydown.enter)="updateDosage(drugOrder, index)"></p-inputNumber>
    </td>
    <td (mouseover)="selectRow(drugOrder._id)">
      <div (mousedown)="menu.toggle($event)" >
        {{ drugOrder.dosage.unit }}
      </div>
      <p-menu #menu [model]="unitMenu" [popup]="true" appendTo="body" styleClass="unit-class"></p-menu>
    </td>
    <td>
      {{ drugOrder.dose.value  }}{{ drugOrder.dose.unit}}
    </td>
    <td (click)="onShowDialog('route',drugOrder._id, drugOrder.medType)" [style]="{'overflow': 'hideen'}">
      {{ drugOrder.route.code }}
    </td>
    <td (click)="onShowDialog('frequency',drugOrder._id, drugOrder.medType)" [ngClass]="{'error': drugOrder | validate: 'frequency'}">
      {{ drugOrder.frequency.code }}
    </td>
    <td [style]="{'text-align': 'center'}">
      <p-checkbox
        [value]="drugOrder.isMill"
        [binary]="true"
        [(ngModel)]="drugOrder.isMill"
      ></p-checkbox>
    </td>
    <td class="text-align-right" (mouseover)="selectRow(drugOrder._id)" (mousedown)="usedDaysMenu.show($event)" [ngClass]="{'error': drugOrder | validate: 'frequency'}">
      <div class="flex-container text-align-right">
        <p-inputNumber class="tableInput" [min]="1" [max]="30" styleClass="inputtext-table" [(ngModel)]="drugOrder.usedDays" (keydown.enter)="setTotalQty(drugOrder, index)"></p-inputNumber>
        <p-menu #usedDaysMenu styleClass="used-days-class" [model]="numberMenu" [popup]="true"  appendTo="body"></p-menu>
      </div>
    </td>
    <td class="text-align-right">{{ drugOrder.total.value }}</td>
    <td (mouseover)="selectRow(drugOrder._id)">
      <div (mousedown)="menu2.toggle($event)">
        {{ drugOrder.total.unit }}
      </div>
      <p-menu #menu2 [model]="unitMenu" [popup]="true" appendTo="body" styleClass="unit-class"></p-menu>
    </td>
    <td class="text-align-center">
      <p-checkbox
        [value]="drugOrder.isSelf"
        [binary]="true"
        [(ngModel)]="drugOrder.isSelf"
      ></p-checkbox>
    </td>
    <td (mousedown)="onEditEnjoin(drugOrder._id)" style="white-space: wrap;overflow: hidden; text-overflow: ellipsis;">{{ drugOrder.advise }} </td>
    <td class="text-align-right">{{ drugOrder.nhiPrice | number : ".2" }}</td>
    <td class="text-align-right">{{ drugOrder.selfPrice | number : ".2" }}</td>
    <td>{{ drugOrder.drug.code }}</td>
  </tr>
</ng-template>
</p-table>

<his-items-dialog
[items]="selectItems"
[title]="selectItemTitle"
[(visible)]="isSelectDialogVisible"
(itemChange)="handleValueChanged($event)"
/>

<!-- <p-dialog header="囑咐訊息" [(visible)]="isEnjoinVisible" [style]="{width: '37.5rem', height: '22.5rem'}" [resizable]="false">
<textarea [(ngModel)]="selectedEnjoin" pInputTextarea></textarea>
<ng-template pTemplate="footer">
<p-button label="取消" (click)="cancelEnjoinEdit()" styleClass="p-button-secondary"></p-button>
<p-button label="確定" (click)="confirmEnjoinEdit()" [style]="{'margin-left': '10px'}"></p-button>
</ng-template>
</p-dialog> -->
